package com.alterdekim.hearthhack.component.processor.client.request.generic;

import com.alterdekim.Protocol;
import com.alterdekim.hearthhack.component.TcpConnection;
import com.alterdekim.hearthhack.util.BattleNetPacket;
import com.alterdekim.hearthhack.util.GetAccountInfoRequest;
import lombok.extern.slf4j.Slf4j;

import static com.alterdekim.hearthhack.util.GameUtilities.generateNotification;
import static com.alterdekim.hearthhack.util.GetAccountInfoRequest.FEATURES;
import static com.alterdekim.hearthhack.util.Util.setInterval;

@Slf4j
public class AvailableFeatures extends GenericParser {

    private void executeFeatures(TcpConnection conn) {
        Protocol.GuardianVars guardianVars = Protocol.GuardianVars.newBuilder()
                .setShowUserUi(1)
                .setClientOptionsUpdateIntervalSeconds(300)
                .build();

        Protocol.Notification n = generateNotification(264, guardianVars.toByteString(), guardianVars.getSerializedSize());

        Protocol.Header header = Protocol.Header.newBuilder()
                .setServiceId(4)
                .setMethodId(1)
                .setToken(conn.nextToken())
                .setStatus(0)
                .setObjectId(0)
                .setSize(n.getSerializedSize())
                .build();

        try {
            conn.send(new BattleNetPacket(header, n.toByteArray()));
        } catch (Exception e) {
            log.error(e.getMessage());
        }
    }

    @Override
    public void parseGenericRequest(int token, TcpConnection conn) throws Exception {
        setInterval(() -> executeFeatures(conn), 4000);
    }

    @Override
    public int getId() {
        return FEATURES.getValue();
    }
}
